<?php
 // file: class.wizard.php
 // desc: PHP "clone" of traditional GUI wizard
 // code: jeff b <jeff@univrel.pr.uconn.edu>
 // lic : GPL, v2

if (!defined(__CLASS_WIZARD_PHP__)) {

define (__CLASS_WIZARD_PHP__, true);


class wizard {

  // *** VARIABLES ***
  var $size;       // size of notebook
  var $page;       // array of pages
  var $name;       // page names
  var $com_vars;   // common variables (hidden)
  var $vars;       // variables passed
  var $cur_page;   // currently displayed page
  var $location;   // location of the page
  var $FGCOLOR;    // foreground color
  var $BGCOLOR;    // background color
  var $FINISH;     // name of the submit button text
  var $REFRESH;    // name of the refresh button text
  var $PREVIOUS;   // name of the previous button text
  var $NEXT;       // name of the next button text
  var $CANCEL;     // name of the cancel button text
  var $common_bar; // common submit/refresh bar at bottom of boxes?
  var $spill_at;   // number to spill over to next row at...

  // *** METHODS ***
  function wizard ($com_vars = "") {
    $this->size       = 0;           // start wizard size at 0
    
    list($this->location, $the_rest) = // initialize location 
      explode ("?", basename($GLOBALS["REQUEST_URI"]));

    $this->FGCOLOR    = "#ffffff";   // default foreground
    $this->BGCOLOR    = "#c5c5c5";   // default background
    $this->FINISH     = "Finish";    // submit button text
    $this->REFRESH    = "Refresh";   // refresh button text
    $this->PREVIOUS   = "Previous";  // previous button text
    $this->NEXT       = "Next";      // next button text
    $this->CANCEL     = "Cancel";    // cancel button text
    if (!empty ($com_vars)) {
      $this->vars[0]  = $com_vars;
      $this->com_vars = true;
    } else { // if there are no common variables
      $this->com_vars = false;
    } // end checking for common variables
  } // end constructor wizard

  // function wizard->get_current_page()
  //   returns the current page of the wizard from global scope
  function get_current_page ($null_var = "") {
    global $__action, $__action_last;
    if (!empty($__action_last)) {
      switch ($__action) {
        case $this->PREVIOUS:
          return ($__action_last - 1);
          break; // if PREVIOUS
        case $this->REFRESH:
          return ($__action_last + 0);
          break; // if REFRESH
        case $this->NEXT:
          return ($__action_last + 1);
          break; // if NEXT
        case $this->CANCEL:
          DIE ("wizard->get_current_page : should not be here!");
          break; // if CANCEL
      } // end switch for action
    } else { // if __action_last is empty
      return 1; // default to page 1
    } // end checking if __action_last is empty
  } // end function wizard->get_current_page

  // function wizard->is_cancelled ()
  //   returns true if the form is ready to be processed
  function is_cancelled ($null_var = "") {
    global $__action;
    return ($__action == $this->CANCEL);
  } // end function wizard->is_cancelled

  // function wizard->is_done ()
  //   returns true if the form is ready to be processed
  function is_done ($null_var = "") {
    global $__action;
    return ($__action == $this->FINISH);
  } // end function wizard->is_done

  // function wizard->add_page (name, array of variables, text)
  //   adds a new "page" to the end of the wizard
  function add_page ($page_name, $page_vars, $page_text) {
    $this->size++; // increment counter
    $this->name[($this->size)] = $page_name;
    $this->vars[($this->size)] = $page_vars;
    $this->page[($this->size)] = $page_text;
  } // end function wizard->add_page

  // function wizard->display ()
  //   displays the current view of the wizard
  function display ($null_var = "") {
    global $__action, $__action_last;

    // here we decide on the current page, and display it
    $this->cur_page = $this->get_current_page(); // grab current page
    if ($this->cur_page < 1) $this->cur_page = 1; // bounds checking
    echo "
      <FORM ACTION=\"".$this->location."\" METHOD=POST>
      <INPUT TYPE=HIDDEN NAME=\"__action_last\"
       VALUE=\"".prepare($this->cur_page)."\">
      <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=2 BGCOLOR=\"".
       $this->FGCOLOR."\">
    ";
    $this->display_hidden_variables($this->cur_page);
    echo "
      <TR><TD COLSPAN=3 BGCOLOR=\"".$this->BGCOLOR."\">
       <CENTER><B>".$this->name[($this->cur_page)]."</B></CENTER>
      </TD></TR><TR><TD COLSPAN=3 BGCOLOR=\"".$this->FGCOLOR."\">
      <!-- wizard body begins here -->
    ";
    echo $this->page[($this->cur_page)];
    echo "
      </TD></TR><TR BGCOLOR=\"".$this->BGCOLOR."\">
       <TD COLSPAN=1 ALIGN=LEFT>
      ".(
       ($this->cur_page > 1) ?
       $this->generate_previous() : $this->generate_cancel()
      )."</TD>
       <TD COLSPAN=1 ALIGN=CENTER>
       ".$this->generate_refresh()."
       </TD>
       <TD COLSPAN=1 ALIGN=RIGHT>
       ".(
       ($this->cur_page < $this->size) ?
       $this->generate_next() : $this->generate_finish()
       )."
       </TD>
      </TR>
      ";
    echo "
      <!-- wizard body ends here -->
      </TD></TR></TABLE></FORM>
    ";
  } // end function wizard->display

  // function wizard->display_hidden_variables (page number)
  //   embeds all of the variables into the page in INPUT TYPE=HIDDEN
  //   tags, skipping over the current page. handles all types, including
  //   arrays.
  function display_hidden_variables($__page_to_display) {
    // loop through pages
    for ($__i=($this->com_vars ? 0 : 1);$__i<=($this->size);$__i++) {
      if (($__page_to_display != $__i) and
          (!empty($this->vars[$__i]))) { // skip current page and empties
        $__this_set = $this->vars[$__i];
        for ($__j=0;$__j<(count($__this_set));$__j++) { // loop vars
	  $__inner_set = $__this_set [$__j];
          global $$__inner_set; // pull into local scope
	  if (!is_array($$__inner_set)) {
            // if it is just scalar, display it
	    echo "<INPUT TYPE=HIDDEN NAME=\"".
	      htmlentities(stripslashes($__inner_set)).
	      "\" VALUE=\"".
	      htmlentities(stripslashes($$__inner_set)).
	      "\">\n";
	  } else { // if it *is* an array
            for ($__k=0;$__k<(count($$__inner_set));$__k++) {
	      echo "<INPUT TYPE=HIDDEN NAME=\"".
	        htmlentities(stripslashes($__inner_set)).
	        "[]\" VALUE=\"".
	        htmlentities(stripslashes(${$__inner_set}[$__k])).
	        "\">\n";
	    } // end looping through array
	  } // end checking for array
	} // end looping through variables
      } // end checking for current page
    } // end looping through pages
  } // end function wizard->display_hidden_variables

  function set_foreground_color ($new_color) {
    $this->FGCOLOR = $new_color;
  } // end function wizard->set_foreground_color

  function set_background_color ($new_color) {
    $this->BGCOLOR = $new_color;
  } // end function wizard->set_background_color

  function set_finish_name ($new_text) {
    $this->FINISH = $new_text;
  } // end function wizard->set_finish_name

  function set_refresh_name ($new_text) {
    $this->REFRESH = $new_text;
  } // end function wizard->set_refresh_name

  function set_cancel_name ($new_text) {
    $this->CANCEL = $new_text;
  } // end function wizard->set_cancel_name

  function generate_finish ($null_val = "") {
    return " <INPUT TYPE=SUBMIT NAME=\"__action\" ".
      "VALUE=\"".htmlentities($this->FINISH)."\">\n";
  } // end function generate_finish

  function generate_refresh ($null_val = "") {
    return " <INPUT TYPE=SUBMIT NAME=\"__action\" ".
      "VALUE=\"".htmlentities($this->REFRESH)."\">\n";
  } // end function generate_refresh

  function generate_previous ($null_val = "") {
    return " <INPUT TYPE=SUBMIT NAME=\"__action\" ".
      "VALUE=\"".htmlentities($this->PREVIOUS)."\">\n";
  } // end function generate_previous

  function generate_next ($null_val = "") {
    return " <INPUT TYPE=SUBMIT NAME=\"__action\" ".
      "VALUE=\"".htmlentities($this->NEXT)."\">\n";
  } // end function generate_next

  function generate_cancel ($null_val = "") {
    return " <INPUT TYPE=SUBMIT NAME=\"__action\" ".
      "VALUE=\"".htmlentities($this->CANCEL)."\">\n";
  } // end function generate_next

} // end class wizard


} // end checking if defined

?>
