<?php
 // file: phone_tools.php
 // desc: phone number tools
 // code: jeff b <jeff@univrel.pr.uconn.edu>
 // lic : GPL, v2

if (!defined(__PHONE_TOOLS_PHP__)) {

define (__PHONE_TOOLS_PHP__, true);

define (PHONE_NUMBER_UNFORMATTED,	0);
define (PHONE_NUMBER_USA, 		1);
define (PHONE_NUMBER_EUROPE, 		2);

function phone_assemble ($phonevar, $phonefmt, $array_index=-1) {
  global ${$phonevar."_1"},
         ${$phonevar."_2"},
         ${$phonevar."_3"},
         ${$phonevar."_4"},
         ${$phonevar."_5"};
  if ($array_index == -1) {
    $p1 = ${$phonevar."_1"};
    $p2 = ${$phonevar."_2"};
    $p3 = ${$phonevar."_3"};
    $p4 = ${$phonevar."_4"};
    $p5 = ${$phonevar."_5"};
  } else {
    $p1 = ${$phonevar."_1"}[$array_index];
    $p2 = ${$phonevar."_2"}[$array_index];
    $p3 = ${$phonevar."_3"}[$array_index];
    $p4 = ${$phonevar."_4"}[$array_index];
    $p5 = ${$phonevar."_5"}[$array_index];
  } // end checking for array index
  
  // return the composited string
  switch ($phonefmt) {
    case PHONE_NUMBER_UNFORMATTED:
     return $p1.$p2.$p3.$p4.$p5;
     break; // end PHONE_NUMBER_UNFORMATTED

    case PHONE_NUMBER_USA:
     return $p1.$p2.$p3.$p4;
     break; // end PHONE_NUMBER_USA

    case PHONE_NUMBER_EUROPE:
     return $p1.$p2.$p3.$p4.$p5;
     break; // end PHONE_NUMBER_EUROPE

    default:
     
     break;
  } // end switching through the formats
} // end function phone_assemble

function phone_entry ($phonevar, $format=PHONE_NUMBER_UNFORMATTED,
                      $array_index=-1) {
  global $$phonevar,
         ${$phonevar."_1"},
         ${$phonevar."_2"},
         ${$phonevar."_3"},
         ${$phonevar."_4"},
         ${$phonevar."_5"};

  // clear buffer
  $buffer = "";

  // move into local vars
  if (($array_index+0)==-1) {
    $w = $$phonevar;
    $p1 = ${$phonevar."_1"};
    $p2 = ${$phonevar."_2"};
    $p3 = ${$phonevar."_3"};
    $p4 = ${$phonevar."_4"};
    $p5 = ${$phonevar."_5"};
    $suffix="";
  } else { // if it *is* an array
    $w = ${$phonevar}[$array_index];
    $p1 = ${$phonevar."_1"}[$array_index];
    $p2 = ${$phonevar."_2"}[$array_index];
    $p3 = ${$phonevar."_3"}[$array_index];
    $p4 = ${$phonevar."_4"}[$array_index];
    $p5 = ${$phonevar."_5"}[$array_index];
    $suffix = "[]";
  } // end moving into local vars

  if (!empty($w) and empty($p1)) {
    // if the whole thing is there, split into parts
    switch ($format) {
      case PHONE_NUMBER_EUROPE:
       $buffer .=
         "<INPUT TYPE=TEXT NAME=\"".prepare($phonevar)."_1\" 
	  SIZE=3 MAXLENGTH=2 VALUE=\"".prepare($p1)."\">
         &nbsp; <B>-</B> &nbsp;
         <INPUT TYPE=TEXT NAME=\"".prepare($phonevar)."_2\" 
	  SIZE=3 MAXLENGTH=2 VALUE=\"".prepare($p2)."\">
         &nbsp; <B>-</B> &nbsp;
         <INPUT TYPE=TEXT NAME=\"".prepare($phonevar)."_3\"
	  SIZE=3 MAXLENGTH=2 VALUE=\"".prepare($p3)."\">
         &nbsp; <B>-</B> &nbsp;
         <INPUT TYPE=TEXT NAME=\"".prepare($phonevar)."_4\" 
	  SIZE=3 MAXLENGTH=2 VALUE=\"".prepare($p4)."\">
         &nbsp; <B>-</B> &nbsp;
         <INPUT TYPE=TEXT NAME=\"".prepare($phonevar)."_5\" 
	  SIZE=3 MAXLENGTH=2 VALUE=\"".prepare($p5)."\">\n";
       break;

      case PHONE_NUMBER_USA:
       $buffer .=
         "<B>(</B> &nbsp;
	  <INPUT TYPE=TEXT NAME=\"".prepare($phonevar)."_1\" 
	  SIZE=4 MAXLENGTH=3 VALUE=\"".prepare($p1)."\">
         &nbsp; <B>)</B> &nbsp;
	  <INPUT TYPE=TEXT NAME=\"".prepare($phonevar)."_2\" 
	  SIZE=4 MAXLENGTH=3 VALUE=\"".prepare($p2)."\">
         &nbsp; <B>-</B> &nbsp;
	  <INPUT TYPE=TEXT NAME=\"".prepare($phonevar)."_3\" 
	  SIZE=5 MAXLENGTH=4 VALUE=\"".prepare($p3)."\">
	 &nbsp; <B>x</B> &nbsp; 
	  <INPUT TYPE=TEXT NAME=\"".prepare($phonevar)."_4\" 
	  SIZE=5 MAXLENGTH=4 VALUE=\"".prepare($p4)."\">\n";
       break;
    
      case PHONE_NUMBER_UNFORMATTED:
      default:
       $buffer .=
         "<INPUT TYPE=TEXT NAME=\"".prepare($phonevar)."\" ". 
	 "SIZE=16 MAXLENGTH=16 VALUE=\"".prepare($w)."\">\n";
       break; // end of default/UNFORMATTED
    } // end format switch
  } // end if not empty whole data

  // return proper part
  return $buffer;
} // end function phone_entry

function phone_vars ($varname) {
  return array ($varname,
                $varname."_1",
		$varname."_2",
		$varname."_3",
		$varname."_4",
		$varname."_5");
} // end function phone_vars

} // end checking if defined

?>
