<?php
 // file: sql_tools.php
 // desc: sql tools
 // code: jeff b <jeff@univrel.pr.uconn.edu>
 // lic : GPL, v2

if (!defined(__SQL_TOOLS_PHP__)) {

define (__SQL_TOOLS_PHP__, true);

function sql_squash ($val, $squash_char=":") {
  if (!is_array ($val)) {
    // handle as scalar
    return $val;
  } else {
    // handle as array ... must recursively loop through *all* elements
    // to make sure that all array parts are handled
    $internal = $val; // pass to here
    reset ($internal); // move pointer to beginning
    while (list ($k, $v) = each ($internal)) {
      $internal["$k"] = sql_squash($v, $squash_char);
    } // end looping
    reset ($internal); // reset pointer (again)
    return implode ($internal, $squash_char);
  } // end checking how to handle

  // if all else fails... false
  return false;
} // end function sql_squash

function sql_expand ($val, $squash_char=":") {
  // return self if not valid
  if (empty ($val)) return $val;

  // perform preliminary explode
  $internal = explode ($squash_char, $val);

  // check to see if we should just return the presented value
  if ((!is_array($internal)) or (count($internal)==1)) return $val;

  // recursive looping through all elements (as in sql_squash)
  reset ($internal); // move pointer to beginning
  while (list ($k, $v) = each ($internal)) {
    $internal["$k"] = sql_expand($v, $squash_char);
  } // end looping

  // return result array
  reset ($internal);
  return $internal;
} // end function sql_expand

} // end checking if defined

?>
